#import "NSArray+BLKArray.h"

@implementation NSArray (BLKArray)

- (NSMutableArray *)blk_take:(NSUInteger)nrToTake {
    return [BLKFunction takeFromArray:self numberOfItems:nrToTake];
}

- (NSMutableArray *)blk_drop:(NSUInteger)nrToDrop {
    return [BLKFunction dropFromArray:self numberOfItems:nrToDrop];
}

- (NSMutableArray *)blk_filter:(BLKTypePred1)block {
    return [BLKFunction filterArray:self withBlock:block];
}

- (NSMutableArray *)blk_map:(BLKTypeFn1)block {
    return [BLKFunction mapArray:self withBlock:block];
}

- (id)blk_reduce:(BLKTypeFn2)block {
    return [BLKFunction reduceArray:self withBlock:block];
}

- (id)blk_fold:(id)accumulator with:(BLKTypeFn2)block {
    return [BLKFunction foldArray:self toAccumulator:accumulator withBlock:block];
}

- (id)blk_conjoin:(id)cage1 {
    return [BLKFunction conjoin:self and:cage1];
}

- (id)blk_conjoin:(id)cage1 and:(id)cage2 {
    return [BLKFunction conjoin:self and:cage1 and:cage2];
}

- (id)blk_conjoin:(id)cage1 interpose:(id)theInterpose {
    return [BLKFunction conjoin:self and:cage1 interpose:theInterpose];
}

- (id)blk_conjoin:(id)cage1 interleave:(NSArray *)theInterleave {
    return [BLKFunction conjoin:self and:cage1 interleave:theInterleave];
}

@end