#import <XCTest/XCTest.h>
#import "BLKCatFunction.h"

#define blk BLKFunction

@interface BLKShortTest : XCTestCase
@end

@implementation BLKShortTest

- (void)testConjoin {
    id theTest;

    theTest = [BLKFunction conjoin:@"[" and:@[@1, @2, @5, @6] interpose:@", " end:@"]"];
    XCTAssertEqualObjects(theTest, @"[1, 2, 5, 6]", @"conjoin string with array");


    theTest = [BLKFunction conjoin:@[] and:@[@1, @2, @5, @6] interleave:@[@"a", @"b"]];
    XCTAssertEqualObjects(theTest, (@[@1, @"a", @2, @"b"]), @"conjoin array with array");

    // dictionaries
    theTest = [BLKFunction conjoin:@{@1 : @2} and:@{@3 : @4}];
    XCTAssertEqualObjects(theTest, (@{@1 : @2, @3 : @4}), @"conjoin two dictionaries");

    theTest = [@"[" blk_conjoin:@[@1,@2,@3] interpose:@", " end:@"]"];
    XCTAssertEqualObjects(theTest, @"[1, 2, 3]", @"conjoin interpose");

    // dictionaries
    theTest = [BLKFunction conjoin:@[] and:@{@3:@4, @5:@6}];
    XCTAssertEqualObjects(theTest, (@[@[@3,@4],@[@5,@6]]), @"conjoin dictionary to array");

    theTest = [@"" blk_conjoin:@{@3:@4, @5:@6} interpose:@", "];
    XCTAssertEqualObjects(theTest, (@"{3:4}, {5:6}"), @"conjoin from dictionary");
    
}

@end
