#import <XCTest/XCTest.h>
#import <BLKFunctional/BLKCatFunction.h>

@interface BLKTestFilter : XCTestCase
@end

@implementation BLKTestFilter

- (void)testFilter {
    NSArray *numberArray = @[@2, @9, @66];

    NSArray *theTest = [numberArray blk_filter:^BOOL(NSNumber *p1) {
        return [p1 intValue] != 9;
    }];
    XCTAssertEqualObjects(theTest, (@[@2, @66]), @"filter out 9");

    theTest = [numberArray blk_filter:BLKPredN(p1.intValue < 10)];
    XCTAssertEqualObjects(theTest, (@[@2, @9]), @"filter out numbers > 10");

    theTest = [@[@"hello", @"world"] blk_filter:BLKPredS([p1 isEqualToString:@"world"])];
    XCTAssertEqualObjects(theTest, (@[@"world"]), @"filter out non world strings");

    theTest = [numberArray blk_filter:BLKPred1([p1 intValue] > 10)];
    XCTAssertEqualObjects(theTest, @[@66], @"filter out numbers < 10");
}
@end
