#import <XCTest/XCTest.h>
#import <BLKFunctional/BLKCatFunction.h>

@interface BLKTestMap : XCTestCase
@end

@implementation BLKTestMap

- (void)testMap {
    NSArray *stringArray = @[@"one", @"two", @"three"];
    NSArray *numberArray = @[@2, @9, @66];
    NSArray *mixedArray = @[@"one", @"two", @2, @9];

    NSArray *theTest = [numberArray blk_map:^(NSNumber *p1) {
        return @([p1 doubleValue] + 2);
    }];
    XCTAssertEqualObjects(theTest, (@[@4, @11, @68]), @"map by adding 2");

    // test macros
    theTest = [stringArray blk_map:BLKFnS([p1 uppercaseString]) ];
    XCTAssertEqualObjects(theTest, (@[@"ONE", @"TWO", @"THREE"]), @"uppercase using macro");

    theTest = [numberArray blk_map:BLKFnN(@(p1.doubleValue * 2)) ];
    XCTAssertEqualObjects(theTest, (@[@4, @18, @132]), @"multiply 2 using macro");

    theTest = [mixedArray blk_map:BLKFn1([p1 description]) ];
    XCTAssertEqualObjects(theTest, (@[@"one", @"two", @"2", @"9"]), @"description using macro");
}

@end
