#import <XCTest/XCTest.h>
#import <BLKFunctional/BLKCatFunction.h>

@interface BLKTestReduce : XCTestCase
@end

@implementation BLKTestReduce

- (void)testReduce {
    NSArray *stringArray = @[@"one", @"two", @"three"];
    NSArray *numberArray = @[@2, @9, @66];

    id theTest;
    theTest = [numberArray blk_reduce:BLKFn2(@([p1 doubleValue] + [p2 doubleValue]))];
    XCTAssertEqualObjects(theTest, @77, @"p1 + p2");

    theTest = [numberArray blk_reduce:BLKFnNN(@(p1.doubleValue + p2.doubleValue) )];
    XCTAssertEqualObjects(theTest, @77, @"p1 + p2");

    // yup this is a little weird for a reduce
    theTest = [numberArray blk_reduce:BLKFnNN([@[] blk_conjoin:p1 and:@(p2.doubleValue + 1)]) ];
    XCTAssertEqualObjects(theTest, (@[@2, @10, @67]), @"p1 conjoin (p2++)");

    theTest = [stringArray blk_reduce:BLKFnSS([p1 stringByAppendingString:p2])];
    XCTAssertEqualObjects(theTest, @"onetwothree", @"p1 + p2");

}


@end
