#import <XCTest/XCTest.h>
#import <BLKFunctional/BLKCatFunction.h>

/**
* Tests for long versions of the Function methods, just to confirm they are correctly defined. Most of
 * the testing will done against the shorter method signatures.
* There are no macros to test.
*/
@interface BlkTestNonCategorized : XCTestCase

@end

@implementation BlkTestNonCategorized


- (void)testWithIndex {
    NSArray *numberArray = @[@2, @9, @66];

    id theTest;
    theTest = [BLKFunction shuffleArray:numberArray];
    XCTAssertTrue([theTest count] == numberArray.count,"non deterministic function");

    theTest = [BLKFunction mapArray:numberArray withIndexedBlock:^id(NSNumber *p1, NSUInteger idx) {
        return @(p1.doubleValue + idx);
    }];
    XCTAssertEqualObjects(theTest, (@[@2, @10, @68]), @"array element + index");

    theTest = [BLKFunction foldArray:numberArray toAccumulator:@5 withIndexedBlock:^(NSNumber *p1, NSNumber *p2, NSUInteger idx) {
        return @([p1 doubleValue] + [p2 doubleValue]);
    }];
    XCTAssertEqualObjects(theTest, @82, @"p1 + p2");
}

@end
